<?php
/*
This file is originally part of TinyMCE_XH.

CMSimple_XH TinyMCE integration - now part of MLDadmin
copyright 2010 - Leen Moerland(www.mldwebsites.nl) and Martin Damken(www.zeichenkombinat.de).
This work (except TinyMCE) is licensed under GNU General Public License Version 3 (GPLv3)
TinyMCE is licensed under LGPL - tinymce.moxiecode.com
---------------------------------------------------------------------
Version:      MLDtinymce_XH 1.1
---------------------------------------------------------------------
Disclaimer:   No warranties at all, use on your own risk!
---------------------------------------------------------------------
Feedback to:  leen [at] mldwebsites [dot] nl
---------------------------------------------------------------------
Tested with browsers:  Mozilla Firefox 3.6.8, Microsoft Internet Explorer 8,
                       Apple Safari 5.0.2
---------------------------------------------------------------------
CHANGELOG:
version 1.1 - (Thanks to Gert from http://www.ge-webdesign.de/ for some good ideas)
 - installed languages to plugin config
 - Updated TinyMCE to v3.3.9.1
 - Updated TinyMCE PHP compressor to v2.0.2
 - emoticons -> emotions, so it actually works in the toolbar
 - apply_source_formatting set from "false" to "true" for clean code
 - Enabled plugin autosave, so you get a warning if you leave the page without saving changes
 - Added entity_encoding setting

*/

//check tinymce folder setting
if(!isset($plugin_cf['MLDadmin']['tinymce_folder'])) {
    $plugin_cf['MLDadmin']['tinymce_folder'] = 'plugins/MLDtinymce_XH/tiny_mce/';
}

//Editor language
$langs = explode(', ', $plugin_cf['MLDadmin']['tinymce_installed_languages']);
if(in_array($sl, $langs)) {
    $editor_lang = $sl;
} else {
    $editor_lang = $plugin_cf['MLDadmin']['tinymce_default_lang'];
}

//check if zlib.output_compression is enabled, if true: normal init, if false: gzip init
$zlib_comp = get_cfg_var('zlib.output_compression');
if(empty($zlib_comp) && $plugin_cf['MLDadmin']['tinymce_use_gzip'] == 'true') {
    $tinymce_js = '<script language="javascript" type="text/javascript" src="'.$pth['folder']['base'].$plugin_cf['MLDadmin']['tinymce_folder'].'tiny_mce_gzip.js"></script>';
    $tinymce_js .= '<script type="text/javascript">
        tinyMCE_GZ.init({
            plugins : "safari,pagebreak,style,layer,table,save,advimage,advlink,emotions,iespell,inlinepopups,insertdatetime,preview,media,searchreplace,print,contextmenu,paste,directionality,fullscreen,noneditable,visualchars,nonbreaking,xhtmlxtras,template,wordcount,autosave",
            themes : "advanced",
            languages : "'.$editor_lang.'",
            disk_cache : true,
            debug : false
        });
        </script>
        ';
} else {
    $tinymce_js = '<script language="javascript" type="text/javascript" src="'.$pth['folder']['base'].$plugin_cf['MLDadmin']['tinymce_folder'].'tiny_mce.js"></script>';
}

//check plugin height
if($plugin_cf['MLDadmin']['tinymce_editor_height'] == '') {
    $plugin_cf['MLDadmin']['tinymce_editor_height'] = 400;
}

//XH settings
if($cf['xhtml']['endtags'] == 'true') {
    $element_format = 'xhtml';
} else {
    $element_format = 'html';
}

if(@is_dir($pth['folder']['base'].$plugin_cf['MLDadmin']['tinymce_folder'])){
    $hjs.= $tinymce_js;
    $hjs .= '
    <script language="javascript" type="text/javascript">
    var myImageList = new Array('.get_the_images($pth['folder']['images']).');
    var myLinkList = new Array('.get_the_links($h, $u, $l, $sn, $pth['folder']['downloads']).');
    
   tinyMCE.init({
        // General options
        mode : "textareas",
        theme : "advanced",
        element_format : "'.$element_format.'",
        language : "'.$editor_lang.'",
        plugins : "safari,pagebreak,style,layer,table,save,advimage,advlink,emotions,iespell,inlinepopups,insertdatetime,preview,media,searchreplace,print,contextmenu,paste,directionality,fullscreen,noneditable,visualchars,nonbreaking,xhtmlxtras,template,wordcount,autosave",

        // Theme options
        theme_advanced_buttons1 : "save,|,bold,italic,underline,strikethrough,|,justifyleft,justifycenter,justifyright,justifyfull,formatselect,fontselect,fontsizeselect",
        theme_advanced_buttons2 : "cut,copy,paste,pastetext,pasteword,|,bullist,numlist,|,outdent,indent,blockquote,|,undo,redo,|,link,unlink,anchor,image,cleanup,help,code",
        theme_advanced_buttons3 : "fullscreen,|,charmap,emotions,|,sub,sup,|,hr,removeformat,visualaid,|,forecolor,backcolor,|,search,replace",
        theme_advanced_buttons4 : "tablecontrols,|,insertdate,inserttime,preview",
        theme_advanced_toolbar_location : "'.$plugin_cf['MLDadmin']['tinymce_editor_location'].'",
        theme_advanced_toolbar_align : "'.$plugin_cf['MLDadmin']['tinymce_toolbar_align'].'",
        theme_advanced_statusbar_location : "'.$plugin_cf['MLDadmin']['tinymce_statusbar_location'].'",
        theme_advanced_source_editor_height : "'.$plugin_cf['MLDadmin']['tinymce_editor_height'].'",

        // Example content CSS (should be your site CSS)
        content_css : "'.$pth['folder']['templates'].$cf['site']['template'].'/stylesteet.css",
        //link and image list
        external_image_list_url: "'.$pth['folder']['base'].$plugin_cf['MLDadmin']['tinymce_folder'].'cmsimple_image_list.js",
        external_link_list_url: "'.$pth['folder']['base'].$plugin_cf['MLDadmin']['tinymce_folder'].'cmsimple_link_list.js",

        // Extra
        plugin_insertdate_dateFormat: "%d-%m-%Y",
        plugin_insertdate_timeFormat: "%H:%M:%S",
        inline_styles : true,
        apply_source_formatting : true,
        relative_urls : true,
        entity_encoding : "'.$plugin_cf['MLDadmin']['tinymce_entity_encoding'].'"
        });
    </script>
    ';

    if(isset($c[$s])) {
        $o.= '<form method="post" id="ta" action="'.$sn.'">'
        .tag('input type="hidden" name="selected" value="'.$u[$s].'"')
        .tag('input type="hidden" name="function" value="save"')
        .'<textarea name="text" id="text" rows="40" cols="80">'
        .$c[$s].'</textarea></form>';
    } else {
        $o.= '<h1>'.$plugin_tx['MLDadmin']['editor_page_not_found'].'</h1><p>'.$plugin_tx['MLDadmin']['editor_choose_page'].'</p>';
    }
} else {
    e('cntopen','folder',$plugin_cf['MLDadmin']['tinymce_folder']);
}


//functions for link- and imagelist
function get_the_images($directory) {
    $files = array();
    $handle = opendir($directory);
    $i = 0;
    while(false !== ($file = readdir($handle))){
        if(preg_match("/(\.jpg$|\.gif$|\.png$|\.jpeg$)/",$file)) {
            $files[$i]['name'] = $file;
            $files[$i]['path'] = $directory. "" .$file;
            $i++;
        }
    }
    closedir($handle);
    sort($files);
    $list = '';
    foreach($files as $i) {
        $list .='["'. ($i['name']). '", "'.($i['path']) . '"],';
    }
    $list = substr($list, 0, -1); // strip the last ","
    return($list);
}

function get_the_links($h, $u, $l, $sn, $downloads_path){
    $list='';
    for($i = 0; $i < count($h); $i++){
        $spacer = '';
            if($l[$i] > 1){
                $spacer = str_repeat('&nbsp;&nbsp;&nbsp;', $l[$i]-1);  // just for indenting lower level "pages"
            }
            $list.='["'.$spacer.substr(str_replace('"','&quot;', $h[$i]), 0, 30).'", "'.$sn.'?'.$u[$i].'"],';
    }
    if(@is_dir($downloads_path)){
        $list .= '["DOWNLOADS:",""],';
        $fs = sortdir($downloads_path);
        foreach($fs as $p){
            if(preg_match("/.+\..+$/",$p)){
                $list .= '["&nbsp;&nbsp;'.substr($p,0,25).' ('.(round((filesize($downloads_path.'/'.$p))/102.4)/10).' KB)", "./?download='.$p.'"],';
            }
        }
    }
    $list = substr($list, 0,-1);
    return($list);
}

 ?>